# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct ContainerServicesApi <: SwaggerApi
    client::Swagger.Client
end

"""
Creates or updates a container service.
Creates or updates a container service with the specified configuration of orchestrator, masters, and agents.
Param: resourceGroupName::String (required)
Param: containerServiceName::String (required)
Param: parameters::ContainerService (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: ContainerService
"""
function _swaggerinternal_containerServicesCreateOrUpdate(_api::ContainerServicesApi, resourceGroupName::String, containerServiceName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PUT", ContainerService, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ContainerService/containerServices/{containerServiceName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "containerServiceName", containerServiceName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function containerServicesCreateOrUpdate(_api::ContainerServicesApi, resourceGroupName::String, containerServiceName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = _swaggerinternal_containerServicesCreateOrUpdate(_api, resourceGroupName, containerServiceName, parameters, api_version, subscriptionId; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function containerServicesCreateOrUpdate(_api::ContainerServicesApi, response_stream::Channel, resourceGroupName::String, containerServiceName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = _swaggerinternal_containerServicesCreateOrUpdate(_api, resourceGroupName, containerServiceName, parameters, api_version, subscriptionId; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

"""
Gets a list of container services in the specified subscription.
Gets a list of container services in the specified subscription. The operation returns properties of each container service including state, orchestrator, number of masters and agents, and FQDNs of masters and agents.
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: ContainerServiceListResult
"""
function _swaggerinternal_containerServicesList(_api::ContainerServicesApi, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", ContainerServiceListResult, "/subscriptions/{subscriptionId}/providers/Microsoft.ContainerService/containerServices", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function containerServicesList(_api::ContainerServicesApi, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = _swaggerinternal_containerServicesList(_api, api_version, subscriptionId; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function containerServicesList(_api::ContainerServicesApi, response_stream::Channel, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = _swaggerinternal_containerServicesList(_api, api_version, subscriptionId; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export containerServicesCreateOrUpdate, containerServicesList
