# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct FirewallRulesApi <: SwaggerApi
    client::Swagger.Client
end

"""

Creates or updates the specified firewall rule. During update, the firewall rule with the specified name will be replaced with this new firewall rule.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: accountName::String (required)
Param: firewallRuleName::String (required)
Param: parameters::CreateOrUpdateFirewallRuleParameters (required)
Param: api_version::String (required)
Return: FirewallRule
"""
function _swaggerinternal_firewallRulesCreateOrUpdate(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, parameters, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PUT", FirewallRule, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "accountName", accountName)  # type String
    Swagger.set_param(_ctx.path, "firewallRuleName", firewallRuleName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function firewallRulesCreateOrUpdate(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, parameters, api_version::String; _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesCreateOrUpdate(_api, subscriptionId, resourceGroupName, accountName, firewallRuleName, parameters, api_version; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function firewallRulesCreateOrUpdate(_api::FirewallRulesApi, response_stream::Channel, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, parameters, api_version::String; _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesCreateOrUpdate(_api, subscriptionId, resourceGroupName, accountName, firewallRuleName, parameters, api_version; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

"""

Deletes the specified firewall rule from the specified Data Lake Store account.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: accountName::String (required)
Param: firewallRuleName::String (required)
Param: api_version::String (required)
Return: Nothing
"""
function _swaggerinternal_firewallRulesDelete(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "DELETE", Nothing, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "accountName", accountName)  # type String
    Swagger.set_param(_ctx.path, "firewallRuleName", firewallRuleName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function firewallRulesDelete(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesDelete(_api, subscriptionId, resourceGroupName, accountName, firewallRuleName, api_version; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function firewallRulesDelete(_api::FirewallRulesApi, response_stream::Channel, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesDelete(_api, subscriptionId, resourceGroupName, accountName, firewallRuleName, api_version; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

"""

Gets the specified Data Lake Store firewall rule.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: accountName::String (required)
Param: firewallRuleName::String (required)
Param: api_version::String (required)
Return: FirewallRule
"""
function _swaggerinternal_firewallRulesGet(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", FirewallRule, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "accountName", accountName)  # type String
    Swagger.set_param(_ctx.path, "firewallRuleName", firewallRuleName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function firewallRulesGet(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesGet(_api, subscriptionId, resourceGroupName, accountName, firewallRuleName, api_version; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function firewallRulesGet(_api::FirewallRulesApi, response_stream::Channel, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesGet(_api, subscriptionId, resourceGroupName, accountName, firewallRuleName, api_version; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

"""

Lists the Data Lake Store firewall rules within the specified Data Lake Store account.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: accountName::String (required)
Param: api_version::String (required)
Return: FirewallRuleListResult
"""
function _swaggerinternal_firewallRulesListByAccount(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", FirewallRuleListResult, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "accountName", accountName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function firewallRulesListByAccount(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, api_version::String; _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesListByAccount(_api, subscriptionId, resourceGroupName, accountName, api_version; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function firewallRulesListByAccount(_api::FirewallRulesApi, response_stream::Channel, subscriptionId::String, resourceGroupName::String, accountName::String, api_version::String; _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesListByAccount(_api, subscriptionId, resourceGroupName, accountName, api_version; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

"""

Updates the specified firewall rule.
Param: subscriptionId::String (required)
Param: resourceGroupName::String (required)
Param: accountName::String (required)
Param: firewallRuleName::String (required)
Param: api_version::String (required)
Param: parameters::UpdateFirewallRuleParameters
Return: FirewallRule
"""
function _swaggerinternal_firewallRulesUpdate(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; parameters=nothing, _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PATCH", FirewallRule, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DataLakeStore/accounts/{accountName}/firewallRules/{firewallRuleName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "accountName", accountName)  # type String
    Swagger.set_param(_ctx.path, "firewallRuleName", firewallRuleName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function firewallRulesUpdate(_api::FirewallRulesApi, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; parameters=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesUpdate(_api, subscriptionId, resourceGroupName, accountName, firewallRuleName, api_version; parameters=parameters, _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function firewallRulesUpdate(_api::FirewallRulesApi, response_stream::Channel, subscriptionId::String, resourceGroupName::String, accountName::String, firewallRuleName::String, api_version::String; parameters=nothing, _mediaType=nothing)
    _ctx = _swaggerinternal_firewallRulesUpdate(_api, subscriptionId, resourceGroupName, accountName, firewallRuleName, api_version; parameters=parameters, _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export firewallRulesCreateOrUpdate, firewallRulesDelete, firewallRulesGet, firewallRulesListByAccount, firewallRulesUpdate
