# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct TrafficAnalyticsApi <: SwaggerApi
    client::Swagger.Client
end

"""

Queries status of flow log and traffic analytics (optional) on a specified resource.
Param: resourceGroupName::String (required)
Param: networkWatcherName::String (required)
Param: parameters::FlowLogStatusParameters (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: FlowLogInformation
"""
function _swaggerinternal_networkWatchersGetFlowLogStatus(_api::TrafficAnalyticsApi, resourceGroupName::String, networkWatcherName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", FlowLogInformation, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/queryFlowLogStatus", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "networkWatcherName", networkWatcherName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function networkWatchersGetFlowLogStatus(_api::TrafficAnalyticsApi, resourceGroupName::String, networkWatcherName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = _swaggerinternal_networkWatchersGetFlowLogStatus(_api, resourceGroupName, networkWatcherName, parameters, api_version, subscriptionId; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function networkWatchersGetFlowLogStatus(_api::TrafficAnalyticsApi, response_stream::Channel, resourceGroupName::String, networkWatcherName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = _swaggerinternal_networkWatchersGetFlowLogStatus(_api, resourceGroupName, networkWatcherName, parameters, api_version, subscriptionId; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

"""

Configures flow log and traffic analytics (optional) on a specified resource.
Param: resourceGroupName::String (required)
Param: networkWatcherName::String (required)
Param: parameters::FlowLogInformation (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: FlowLogInformation
"""
function _swaggerinternal_networkWatchersSetFlowLogConfiguration(_api::TrafficAnalyticsApi, resourceGroupName::String, networkWatcherName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", FlowLogInformation, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkWatchers/{networkWatcherName}/configureFlowLog", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "networkWatcherName", networkWatcherName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    return _ctx
end

function networkWatchersSetFlowLogConfiguration(_api::TrafficAnalyticsApi, resourceGroupName::String, networkWatcherName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = _swaggerinternal_networkWatchersSetFlowLogConfiguration(_api, resourceGroupName, networkWatcherName, parameters, api_version, subscriptionId; _mediaType=_mediaType)
    Swagger.exec(_ctx)
end

function networkWatchersSetFlowLogConfiguration(_api::TrafficAnalyticsApi, response_stream::Channel, resourceGroupName::String, networkWatcherName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = _swaggerinternal_networkWatchersSetFlowLogConfiguration(_api, resourceGroupName, networkWatcherName, parameters, api_version, subscriptionId; _mediaType=_mediaType)
    Swagger.exec(_ctx, response_stream)
end

export networkWatchersGetFlowLogStatus, networkWatchersSetFlowLogConfiguration
